#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>


// struktura ktra bdzie odbierana
typedef struct {
   long type;
   char body[100];
} msg;

int main(){
   char temp[20];
   msg wiad; // zmienna do ktrej bd odbierane dane
   int id, result, msgtyp;
   strcpy(wiad.body, ""); // wyczyszczenie treci wiadomoci
   id= msgget(1642,0); // pobranie identyfikatora kolejki 
   if(id < 0){ // jeli nie udao si otworzy
      printf("Msggetrcv: %d\n", id); // to wywal komunikat
      exit(1); // i wyjd z programu
   }
   scanf("%s", temp); // odczyt z klawiatury
   msgtyp = atoi(temp); // konwersja na liczb
   result = msgrcv(id, &wiad, sizeof(wiad.body), msgtyp, IPC_NOWAIT); // odczytaj wiadomo
   if (result>-1) {
      wiad.body[result] = 0; // dodanie zera na kocu odczytanej wiadomoci
      printf("%d: %s\n", result, wiad.body); // wywietlenie iloci znakw
      msgctl(id, IPC_RMID, (struct msqid_ds *)0); // Usunicie wiadomoci z kolejki
   } else {
      printf("nie dao si odczyta z kolejki wiadom. o pod. typie\n");
   }
   return 0;
}
